<?php
function &RSStart()
{
    $module        = RSSelectModule();

    // The class name is always mod_modulename.php
    $class        = 'mod_'.$module;    

    $path        = sprintf(RS_MODULE_PATH, $module);
    $sql        = sprintf($path.RS_MODULE_SQL);
    $modulecode     = $path.'index.php';
    
    //GRAB THE SQL
    if (file_exists($sql)) include($sql);
    require($modulecode);

    //~ Include The Class Of That Module
    new $class();
}

function RSSelectModule()
{
    $module = RequestAll('module');
    $auth   = RequestCookie('authorised'); // gets set from within AUTH module

    if (strlen($module) == 0)
    {
        //$module = ($auth == 1) ? RS_DEFAULT_MODULE : RS_AUTH_MODULE;
        $module = RS_DEFAULT_MODULE;
    }

    if($module==RS_ADMIN_MODULE)
    $file = RS_SYSTEM_PATH.RS_ADMIN_MODULE.'/index.php';
    else
    $file = sprintf(RS_MODULE_PATH.'index.php', $module);

    if (file_exists($file))
    {
        return $module;
    }
    else
    {
        setRSRedirect('index.php?module='.RS_ERROR_MODULE.'&error=500');
        return 0;
    }
}



function RsReadFile($file, $mode='r')
{
    if (!PHP43) // 4.3.0
    {
    $fp = @fopen($file, $mode);
    if (!($fp)) 
    {
        return 0;
    }

    $tmp = null;
    while (!feof($fp))
    {
        $tmp .= fread($fp, 4096);
    }
    return $tmp;
    }
    else 
    {
    return file_get_contents($file);
    }
}

function RSCopyright()
{
    return '&copy; <a href="http://www.therssoftware.com/" target="_blank">The RS Software</a> 2003-2007';
}

function RSSeed()
{
    list($usec, $sec) = explode(' ', microtime());
    $microtime = ((float)$usec + (float)$sec);
    srand((double) $microtime * 1000000);
    return $microtime;
}

function RSPrintDate($date)
{
    if (intval($date) > 0) 
    {
        $date = explode("-" ,$date);
        $date =  date (RS_FORMAT_DATE, mktime(0,0,0,$date[ 1],$date[ 2],$date[ 0]));
    }
    else
    {
        $date = "--";
    }
    return $date;
}

function RsDeleteFile($file)
{
    $fname   = $file['FileName'];
    $rname   = $file['RealName'];
    $type    = $file['Type'];
    $size    = $file['Size'];
    $project = $file['ProjectID'];
    $task    = $file['TaskID'];

    // trailing slash - checks for trailing slash, just incase someone didn't put it in
    $trailer = substr(SYS_FILEPATH, strlen(SYS_FILEPATH) - 1, 1);
    if ( ($trailer != '\\') && ($trailer != '/') )
    {
    $filepath = SYS_FILEPATH . '/';
    }
    else
    {
    $filepath = SYS_FILEPATH;
    }
    //~ trailing slash

    $project_dir = str_pad($project, 7, '0', STR_PAD_LEFT);
    $task_dir    = str_pad($task, 7, '0', STR_PAD_LEFT);
    $file    = $filepath . $project_dir . '/' . $task_dir . '/' . $rname;
    if ( file_exists($file) )
    {
    unlink($file);
    return true;
    }
    return false;
}


function RSDownloadFile($file)
{
    $fname   = $file['FileName'];
    $rname   = $file['RealName'];
    $type    = $file['Type'];
    $size    = $file['Size'];

    // trailing slash - checks for trailing slash, just incase someone didn't put it in
    $trailer = substr(SYS_FILEPATH, strlen(SYS_FILEPATH) - 1, 1);
    if ( ($trailer != '\\') && ($trailer != '/') ) 
    {
    $filepath = SYS_FILEPATH . '/';
    }
    else
    {
    $filepath = SYS_FILEPATH;
    }
    //~ trailing slash

    $project_dir = str_pad($project, 7, '0', STR_PAD_LEFT);
    $task_dir     = str_pad($task, 7, '0', STR_PAD_LEFT);
    $file     = $filepath . $project_dir . '/' . $task_dir . '/' . $rname;
    if ( file_exists($file) ) 
    {
    header('Content-length: '.$size);
    header('Content-type: ' . $type);
    header('Content-disposition: inline; filename='.$fname);
    readfile($file);
    return true;
    }
    return false;
}

function cuLicenseName() { return LICENSE_NAME; }
function cuLicenseCompany() { return LICENSE_COMPANY; }
function cuVersion() { return CU_PRODUCT_VERSION; }
function cuProductName() { return CU_PRODUCT_NAME; }


function delete_all_from_dir($Dir){
    // delete everything in the directory
    if ($handle = @opendir($Dir)) 
    {
        while (($file = readdir($handle)) !== false) 
        {
            if ($file == "." || $file == "..") 
            {
                continue;
            }
            if (is_dir($Dir.$file))
            {
                // call self for this directory
                delete_all_from_dir($Dir.$file.'/');
                chmod($Dir.$file, 0777);
                rmdir($Dir.$file); //remove this directory
            }
            else
            {
                chmod($Dir.$file,0777);
                unlink($Dir.$file); // remove this file
            }
        }
    }
    @closedir($handle);
}

function RsPaginate($num_records, $limit, $url, $offset, &$tmpl) {
                $prevtext = MSG_PREV;
                $nexttext = MSG_NEXT;
                $alltext = MSG_ALL;
                if ($offset > 0)
                {
                    $prevoffset = $offset - $limit;
                    $prev = '<a class="linkon" href="'.$url.'&amp;start='.$prevoffset.'">' . $prevtext . '</a> | ';
                }

                //Page Numbers
                     $num_pages = $num_records / $limit;
                    if ($num_pages>1)
                    {
                        for ($i=0,$j=1; $i < $num_pages; $i++,$j++)
                        {
                            $start = $limit * $i;
                            $link = $j;
                            if ($start == $offset)
                                $link = '<strong>'.$j.'</strong>';
                            $pages .= '<a class="linkon" href="'.$url.'&amp;start='.$start.'">'.$link.'</a> ';
                        }

                        //Show All
                        $all = ' | <a class="linkon" href="'.$url.'&amp;start=all">'.$alltext.'</a>';

                    }

                if (!(($offset + $limit) >= $num_records))
                {
                    $newoffset = $offset + $limit;
                    $next = '| <a class="linkon" href="'.$url.'&amp;start='.$newoffset.'">' . $nexttext . '</a>';
                }

                $tmpl['PREV'] = $prev;
                $tmpl['NEXT'] = $next;
                $tmpl['PAGES'] = $pages;
                $tmpl['ALL'] = $all;

                return $tmpl;
}

?>
